
/* Chrysalide - Outil d'analyse de fichiers binaires
 * wide.h - prototypes pour la transcription d'une séquence d'octets en UTF-16
 *
 * Copyright (C) 2023 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ANALYSIS_SCAN_PATTERNS_MODIFIERS_WIDE_H
#define _ANALYSIS_SCAN_PATTERNS_MODIFIERS_WIDE_H


#include <glib-object.h>


#include "../modifier.h"



#define G_TYPE_SCAN_WIDE_MODIFIER            g_scan_wide_modifier_get_type()
#define G_SCAN_WIDE_MODIFIER(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), G_TYPE_SCAN_WIDE_MODIFIER, GScanWideModifier))
#define G_IS_SCAN_WIDE_MODIFIER(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), G_TYPE_SCAN_WIDE_MODIFIER))
#define G_SCAN_WIDE_MODIFIER_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_SCAN_WIDE_MODIFIER, GScanWideModifierClass))
#define G_IS_SCAN_WIDE_MODIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_SCAN_WIDE_MODIFIER))
#define G_SCAN_WIDE_MODIFIER_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_SCAN_WIDE_MODIFIER, GScanWideModifierClass))


/* Transcription d'une séquence d'octets en UTF-16 (instance) */
typedef GScanTokenModifier GScanWideModifier;

/* Transcription d'une séquence d'octets en UTF-16 (classe) */
typedef GScanTokenModifierClass GScanWideModifierClass;


/* Indique le type défini pour une transcription d'une séquence d'octets en UTF-16. */
GType g_scan_wide_modifier_get_type(void);

/* Construit un modificateur livrant des octets en UTF-16. */
GScanTokenModifier *g_scan_wide_modifier_new(void);



#endif  /* _ANALYSIS_SCAN_PATTERNS_MODIFIERS_WIDE_H */
